Module javafx.controls
Package javafx.scene.control.skin

# Class ComboBoxListViewSkin<T>

java.lang.Object
javafx.scene.control.SkinBase<ComboBoxBase<T>>
javafx.scene.control.skin.ComboBoxBaseSkin<T>
javafx.scene.control.skin.ComboBoxPopupControl<T>
javafx.scene.control.skin.ComboBoxListViewSkin<T>

All Implemented Interfaces:
  `Skin<ComboBoxBase<T>>`

public class ComboBoxListViewSkin<T> extends ComboBoxPopupControl<T>
Default skin implementation for the `ComboBox` control.

Since:
  9
See Also:
  - `ComboBox`

## Property Summary

Properties
Type
Property
Description
`final BooleanProperty`
`hideOnClick`
By default this skin hides the popup whenever the ListView is clicked in.

## Constructor Summary

Constructors
Constructor
Description
`ComboBoxListViewSkin(ComboBox<T> control)`
Creates a new ComboBoxListViewSkin instance, installing the necessary child nodes into the Control `children` list, as well as the necessary input mappings for handling key, mouse, etc events.

## Method Summary

Modifier and Type
Method
Description
`protected double`
`computeMaxHeight(double width, double topInset, double rightInset, double bottomInset, double leftInset)`
Computes the maximum allowable height of the Skin, based on the provided width.
`protected double`
`computeMaxWidth(double height, double topInset, double rightInset, double bottomInset, double leftInset)`
Computes the maximum allowable width of the Skin, based on the provided height.
`protected double`
`computeMinHeight(double width, double topInset, double rightInset, double bottomInset, double leftInset)`
Computes the minimum allowable height of the Skin, based on the provided width.
`protected double`
`computeMinWidth(double height, double topInset, double rightInset, double bottomInset, double leftInset)`
Computes the minimum allowable width of the Skin, based on the provided height.
`protected double`
`computePrefHeight(double width, double topInset, double rightInset, double bottomInset, double leftInset)`
Calculates the preferred height of this `SkinBase`.
`protected double`
`computePrefWidth(double height, double topInset, double rightInset, double bottomInset, double leftInset)`
Calculates the preferred width of this `SkinBase`.
`void`
`dispose()`
Called by a Skinnable when the Skin is replaced on the Skinnable.
`protected StringConverter<T>`
`getConverter()`
Subclasses are responsible for getting the converter.
`Node`
`getDisplayNode()`
This method should return a Node that will be positioned within the ComboBox 'button' area.
`protected TextField`
`getEditor()`
Subclasses are responsible for getting the editor.
`Node`
`getPopupContent()`
This method should return the Node that will be displayed when the user clicks on the ComboBox 'button' area.
`final BooleanProperty`
`hideOnClickProperty()`
By default this skin hides the popup whenever the ListView is clicked in.
`final boolean`
`isHideOnClick()`
Gets the value of the `hideOnClick` property.
`protected void`
`layoutChildren(double x, double y, double w, double h)`
Called during the layout pass of the scenegraph.
`Object`
`queryAccessibleAttribute(AccessibleAttribute attribute, Object... parameters)`
This method is called by the assistive technology to request the value for an attribute.
`final void`
`setHideOnClick(boolean value)`
Sets the value of the `hideOnClick` property.

### Methods inherited from class javafx.scene.control.skin.ComboBoxPopupControl

`hide, show`

### Methods inherited from class javafx.scene.control.skin.ComboBoxBaseSkin

`computeBaselineOffset`

### Methods inherited from class javafx.scene.control.SkinBase

`consumeMouseEvents, executeAccessibleAction, getChildren, getClassCssMetaData, getCssMetaData, getNode, getSkinnable, layoutInArea, layoutInArea, layoutInArea, positionInArea, positionInArea, pseudoClassStateChanged, registerChangeListener, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, unregisterChangeListeners`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Property Details

### hideOnClick

public final BooleanProperty hideOnClickProperty
By default this skin hides the popup whenever the ListView is clicked in. By setting hideOnClick to false, the popup will not be hidden when the ListView is clicked in. This is beneficial in some scenarios (for example, when the ListView cells have checkboxes).

See Also:
  - `isHideOnClick()`
  - `setHideOnClick(boolean)`
  - `hideOnClickProperty()`

## Constructor Details

### ComboBoxListViewSkin

public ComboBoxListViewSkin(ComboBox<T> control)
Creates a new ComboBoxListViewSkin instance, installing the necessary child nodes into the Control `children` list, as well as the necessary input mappings for handling key, mouse, etc events.

Parameters:
  `control` - The control that this skin should be installed onto.

## Method Details

### hideOnClickProperty

public final BooleanProperty hideOnClickProperty()
By default this skin hides the popup whenever the ListView is clicked in. By setting hideOnClick to false, the popup will not be hidden when the ListView is clicked in. This is beneficial in some scenarios (for example, when the ListView cells have checkboxes).

Returns:
  the `hideOnClick` property
See Also:
  - `isHideOnClick()`
  - `setHideOnClick(boolean)`

### isHideOnClick

public final boolean isHideOnClick()
Gets the value of the `hideOnClick` property.

Property description:
  By default this skin hides the popup whenever the ListView is clicked in. By setting hideOnClick to false, the popup will not be hidden when the ListView is clicked in. This is beneficial in some scenarios (for example, when the ListView cells have checkboxes).
Returns:
  the value of the `hideOnClick` property
See Also:
  - `setHideOnClick(boolean)`
  - `hideOnClickProperty()`

### setHideOnClick

public final void setHideOnClick(boolean value)
Sets the value of the `hideOnClick` property.

Property description:
  By default this skin hides the popup whenever the ListView is clicked in. By setting hideOnClick to false, the popup will not be hidden when the ListView is clicked in. This is beneficial in some scenarios (for example, when the ListView cells have checkboxes).
Parameters:
  `value` - the value for the `hideOnClick` property
See Also:
  - `isHideOnClick()`
  - `hideOnClickProperty()`

### dispose

public void dispose()
Called by a Skinnable when the Skin is replaced on the Skinnable. This method allows a Skin to implement any logic necessary to clean up itself after the Skin is no longer needed. It may be used to release native resources. The methods `Skin.getSkinnable()` and `Skin.getNode()` should return null following a call to dispose. Calling dispose twice has no effect.

Specified by:
  `dispose` in interface `Skin<T>`
Overrides:
  `dispose` in class `SkinBase<ComboBoxBase<T>>`

### getEditor

protected TextField getEditor()
Subclasses are responsible for getting the editor. This will be removed in FX 9 when the editor property is moved up to ComboBoxBase with JDK-8130354 Note: ComboBoxListViewSkin should return null if editable is false, even if the ComboBox does have an editor set.

Specified by:
  `getEditor` in class `ComboBoxPopupControl<T>`
Returns:
  the editor

### getConverter

protected StringConverter<T> getConverter()
Subclasses are responsible for getting the converter. This will be removed in FX 9 when the converter property is moved up to ComboBoxBase with JDK-8130354.

Specified by:
  `getConverter` in class `ComboBoxPopupControl<T>`
Returns:
  the string converter

### getDisplayNode

public Node getDisplayNode()
This method should return a Node that will be positioned within the ComboBox 'button' area.

Specified by:
  `getDisplayNode` in class `ComboBoxBaseSkin<T>`
Returns:
  the node that will be positioned within the ComboBox 'button' area

### getPopupContent

public Node getPopupContent()
This method should return the Node that will be displayed when the user clicks on the ComboBox 'button' area.

Specified by:
  `getPopupContent` in class `ComboBoxPopupControl<T>`
Returns:
  the Node that will be displayed when the user clicks on the ComboBox 'button' area

### computeMinWidth

protected double computeMinWidth(double height, double topInset, double rightInset, double bottomInset, double leftInset)
Computes the minimum allowable width of the Skin, based on the provided height.

Overrides:
  `computeMinWidth` in class `SkinBase<ComboBoxBase<T>>`
Parameters:
  `height` - The height of the Skin, in case this value might dictate the minimum width.
  `topInset` - the pixel snapped top inset
  `rightInset` - the pixel snapped right inset
  `bottomInset` - the pixel snapped bottom inset
  `leftInset` - the pixel snapped left inset
Returns:
  A double representing the minimum width of this Skin.

### computePrefWidth

protected double computePrefWidth(double height, double topInset, double rightInset, double bottomInset, double leftInset)
Calculates the preferred width of this `SkinBase`. The default implementation calculates this width as the width of the area occupied by its managed children when they are positioned at their current positions at their preferred widths.

Overrides:
  `computePrefWidth` in class `ComboBoxBaseSkin<T>`
Parameters:
  `height` - the height that should be used if preferred width depends on it
  `topInset` - the pixel snapped top inset
  `rightInset` - the pixel snapped right inset
  `bottomInset` - the pixel snapped bottom inset
  `leftInset` - the pixel snapped left inset
Returns:
  the calculated preferred width

### computeMaxWidth

protected double computeMaxWidth(double height, double topInset, double rightInset, double bottomInset, double leftInset)
Computes the maximum allowable width of the Skin, based on the provided height.

Overrides:
  `computeMaxWidth` in class `ComboBoxBaseSkin<T>`
Parameters:
  `height` - The height of the Skin, in case this value might dictate the maximum width.
  `topInset` - the pixel snapped top inset
  `rightInset` - the pixel snapped right inset
  `bottomInset` - the pixel snapped bottom inset
  `leftInset` - the pixel snapped left inset
Returns:
  A double representing the maximum width of this Skin.

### computeMinHeight

protected double computeMinHeight(double width, double topInset, double rightInset, double bottomInset, double leftInset)
Computes the minimum allowable height of the Skin, based on the provided width.

Overrides:
  `computeMinHeight` in class `SkinBase<ComboBoxBase<T>>`
Parameters:
  `width` - The width of the Skin, in case this value might dictate the minimum height.
  `topInset` - the pixel snapped top inset
  `rightInset` - the pixel snapped right inset
  `bottomInset` - the pixel snapped bottom inset
  `leftInset` - the pixel snapped left inset
Returns:
  A double representing the minimum height of this Skin.

### computePrefHeight

protected double computePrefHeight(double width, double topInset, double rightInset, double bottomInset, double leftInset)
Calculates the preferred height of this `SkinBase`. The default implementation calculates this height as the height of the area occupied by its managed children when they are positioned at their current positions at their preferred heights.

Overrides:
  `computePrefHeight` in class `ComboBoxBaseSkin<T>`
Parameters:
  `width` - the width that should be used if preferred height depends on it
  `topInset` - the pixel snapped top inset
  `rightInset` - the pixel snapped right inset
  `bottomInset` - the pixel snapped bottom inset
  `leftInset` - the pixel snapped left inset
Returns:
  the calculated preferred height

### computeMaxHeight

protected double computeMaxHeight(double width, double topInset, double rightInset, double bottomInset, double leftInset)
Computes the maximum allowable height of the Skin, based on the provided width.

Overrides:
  `computeMaxHeight` in class `ComboBoxBaseSkin<T>`
Parameters:
  `width` - The width of the Skin, in case this value might dictate the maximum height.
  `topInset` - the pixel snapped top inset
  `rightInset` - the pixel snapped right inset
  `bottomInset` - the pixel snapped bottom inset
  `leftInset` - the pixel snapped left inset
Returns:
  A double representing the maximum height of this Skin.

### layoutChildren

protected void layoutChildren(double x, double y, double w, double h)
Called during the layout pass of the scenegraph.

Overrides:
  `layoutChildren` in class `ComboBoxBaseSkin<T>`
Parameters:
  `x` - the x position
  `y` - the y position
  `w` - the width
  `h` - the height

### queryAccessibleAttribute

public Object queryAccessibleAttribute(AccessibleAttribute attribute, Object... parameters)
This method is called by the assistive technology to request the value for an attribute.

This method is commonly overridden by subclasses to implement attributes that are required for a specific role.
If a particular attribute is not handled, the superclass implementation must be called.

Overrides:
  `queryAccessibleAttribute` in class `SkinBase<ComboBoxBase<T>>`
Parameters:
  `attribute` - the requested attribute
  `parameters` - optional list of parameters
Returns:
  the value for the requested attribute
See Also:
  - `AccessibleAttribute`
  - `Node.queryAccessibleAttribute(javafx.scene.AccessibleAttribute, java.lang.Object...)`